**********************************************************************************
* POKUSN OTVORENIE Visual FOXPRO databzy priamo bez bez pripjania ku serveru
**********************************************************************************
* pouit ODBC driver Visual Foxpro ale teoreticky mon poui hociak driver
* a akkovek databzu potom, napr. MySQL,Access,Oracle,...

* 25.11.2017 - prava pre otestovanie otvorenia OLP , OLPD aj cez sie VPN WAN
* alie experimenty 27.2.2017
* otestovan, funkn 14.12.2016

#include "sql.ch"
#include "sqlext.ch"
#include "dcdialog.ch"

PROCEDURE DbeSys() ; Return
PROCEDURE AppSys() ; Return

****************
PROCEDURE Main()
****************

* zmena na public aby som nemusel posiela funkcim
*LOCAL oConnection, oCursorolp, oCursorolpd, GetList[0], GetOptions, oBrowse,oBrowsed,oBrowseds, i, cStatement, ;
*      cConnectString, cTableName, aSort,oDataset

PUBLIC oConnectionp, oConnectionpd, oCursorolp, oCursorolpd, GetList := {}, GetOptions, oBrowse,oBrowsed,oBrowseds, i, cStatementp, cStatementpd, ;
      cConnectStringp,cConnectStringpd, cTableName, aSort,oDataset,bOLPD
*PUBLIC cislo:="1"
PUBLIC cislo,bcislo,bstatementd

PUBLIC aOLPD:={}	// pomocn pole pre zobrazenie datasetu

// set up default configuration of GUI browse headers for sorting
aSort := Array(4)
aSort[1] := GRA_CLR_WHITE    // Sort Selected Color (Foreground)
aSort[2] := GRA_CLR_RED      // Sort Selected Color (Background)
aSort[3] := GRA_CLR_WHITE    // Sort Unselected Color (Foreground)
aSort[4] := GRA_CLR_DARKGRAY // Sort Unselected Color (Background)

DC_BrowseSort(aSort)

*******************************************************************************************
* nastavenie charset OEM pouvam v Raukn, pre OLP by malo vyhovova lebo nieje diakritika
*******************************************************************************************
*SET CHARSET TO ANSI
SET CHARSET TO OEM                // toto funguje ok 

* zapamtanie si pozcie a rozmeru okna pre budce spustenie
DC_AutoRestoreWindow({HKEY_LOCAL_MACHINE,'Software\Donnay Software\Samples\Windows'})

*  // this will connect to our MS Access TEST.MDB database:
*  #define __CONNECT_STRING  'DBQ=data\test.mdb;Driver={Microsoft Access Driver (*.mdb)};UID=admin;'
*  #define __STATEMENT       'SELECT * FROM [customer],[orders] '+;
*                            'WHERE [orders].[customer id]=[customer].[customer id] '+;
*                            'ORDER BY [customer name]'

********************************
* zadefinovanie ConnectStringu
********************************
* nzov databzy a adresr pevne zadan u v ConnectStringu
*cConnectString := "SourceDB=d:\#POKUSY\SQLDBFFOXPRO5;DRIVER=Microsoft Visual FoxPro Driver;SERVER=(local);UID=;PWD=;DATABASE=VL800490.DBF;SourceType=DBF;Exclusive=No;Collate=Machine;NULL=NO;DELETED=NO;BACKGROUNDFETCH=NO"
* parametre :
* SourceDB=d:\#POKUSY\SQLDBFFOXPRO5 - adresr, kde bude hada databzu
* DRIVER=Microsoft Visual FoxPro Driver - driver, toto ODBC , sas windowsu alebo dointalova vi VisualFoxpro ODBC asi mm z WRKN
*        ODBC Driver 13 for SQL Server - skal som ale nefunguje
* SERVER=(local) - server, tu v tomto prpade local, ale pre sieov prevdzku by som mal poui asi server ? licencie ako ? obmedzenia ODBC
* UID=;PWD= - meno a heslo uvatea
* DATABASE=VL800490.DBF - nzov databzovho sboru, v tomto prpade DBF 
* SourceType=DBF - typ zdroja, tu DBF	
* Exclusive=No - otvorenie len exclusive
* Collate=Machine - triedenie, poui ale Collate=Slovak !
*         SQL_Slovak_CP_1250_CI_AS - toto ODBC VFP nepodporuje, mono in drivery
* NULL=NO - povolenie NULL hodnt NO, zakzanie YES, voli NO !
* DELETED=NO - nezobrazenie zmazanch zznamov NO, zobrazenie YES, voli YES inak zobraz aj zmazan
* BACKGROUNDFETCH=NO - neviem, asi na pozad nahrvanie aktualizcie dt

*************************
* pre databzu na MYHP1
******************************************************
cConnectStringp := "SourceDB=d:\#pokusy\SQLDBFFOXPRO5;DRIVER=Microsoft Visual FoxPro Driver;SERVER=(local);UID=;PWD=;SourceType=DBF;Exclusive=No;Collate=Slovak;NULL=NO;DELETED=YES;BACKGROUNDFETCH=NO"
cConnectStringpd := "SourceDB=d:\#pokusy\SQLDBFFOXPRO5;DRIVER=Microsoft Visual FoxPro Driver;SERVER=(local);UID=;PWD=;SourceType=DBF;Exclusive=No;Collate=Slovak;NULL=NO;DELETED=YES;BACKGROUNDFETCH=NO"
******************************************************
*****************************************
* pre databzu na MISK200 cez VPN ako Z: 
******************************************************
*cConnectString := "SourceDB=z:\data\RAUKNOF_2000_2016.OLP;DRIVER=Microsoft Visual FoxPro Driver;SERVER=(local);UID=;PWD=;SourceType=DBF;Exclusive=No;Collate=Slovak;NULL=NO;DELETED=YES;BACKGROUNDFETCH=NO"
******************************************************

* nastavenie nzvov databz, ak napr. by som spjal dve cez UNION alebo JOIN
******************************************************************************
cTableName1 := 'VL800490.DBF'	// toto me by nastaven pri cconnectstring alebo tu
cTableName2 := 'VL801011.DBF'	// toto me by nastaven pri cconnectstring alebo tu

* nastavenie kurzora, teda o sa zobraz , vrtane podmienok at.
**********************************************************************************
* obyajn otvorenie databzy so zotriedenm poda VLA
*cStatement := 'SELECT * FROM VL800490.DBF ORDER BY VLA COLLATE Slovak_CI_AI'
*cStatement := 'SELECT VLA COLLATE Slovak_CI_AI FROM VL800490.DBF ORDER BY VLA'
* TOTO OK,  otvorenie , collate je nastaven hore pri driveri a to SLOVAK, toto funguje OK triedenie sprvne ako WISKN, ale indexov potrebujem viac
*****************************************************************

*********************************************************************************
* VBER DATABZOVHO SBORU A VYTVORENIE STATEMENTU PRE OTVORENIE, POLIA, ORDER
*********************************************************************************
************************
* pre databzu OLP,OLPD - NA MYHP1 ale ete star RAUKN RAUKN_OLP
************************
* OLP *
cStatementp := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP.DBF ORDER BY C_PROC '	 // OLP
* OLPD *
cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF ORDER BY C_PROC '	 // OLPD
* upraven pre rozlenie rovnakch nzvov pol, ale pri ORDER neme by RAUKN_OLP_D, inak chyba seek
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF ORDER BY C_PROC '	 // OLPD
***********************************************************************************************

*******************
* pre databzu OLP - NA MISK200 u nov RAUKN RAUKN_OLP_MISK200
********************
*cStatementp := 'SELECT C_PROC,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_MISK200.DBF ORDER BY C_PROC '
***********************************************************************************************

* tu ukka , ako odfiltrova poadovan meno, ale mus by zachovan vekos psmen a diakritika tak isto
*cStatementp := 'SELECT VLA FROM VL800490.DBF WHERE VLA LIKE "Babjak%" ORDER BY VLA'	

* tu ukka asi ako odstrni diakritiku, resp. ignorova ju, ale neviem to poui 
/*
cStatementp := 'SELECT strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran('+;
		'strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(VLA, "", "a")'+;
		', "", "c"), "", "d"), "", "e"), "", "e"), "", "i"), "", "l"), "", "n"), "", "o"'+;
		'), "", "r"), "", "s"), "", "t"), "", "u"), "", "u"), "", "y"), "", "z"), "", "a"'+;
		'), "", "o"), "", "u") AS VLA'+;
		' FROM VL800490.DBF'+;
		' WHERE VLA LIKE "Babjak%"'+;
		' ORDER BY VLA'
*		' WHERE VLA LIKE "Babjak%"'+;
*/

* tu iba ukka ako viem poui funkciu UPPER v SELECTe
*cStatementp := 'SELECT UPPER(VLA) AS VLASTNIK FROM VL800490.DBF ORDER BY VLA'	// funguje ale mus by zachovan vekos psmen
*cStatementp := 'SELECT * FROM VL800490.DBF ORDER BY PRI,MNO'
*cStatementp := 'SELECT * FROM VL800490.DBF JOIN SELECT * FROM VL801011.DBF'
*cStatementp := 'SELECT * FROM VL800490.DBF UNION SELECT * FROM VL801011.DBF'
*cStatementp := 'SELECT * FROM VL800490.DBF ORDER BY VLA'
*cStatementp := 'SELECT * FROM VL800490.DBF WHERE CLV>0 .and. CLV<100 ORDER BY VLA'
*cStatementp := 'SELECT * FROM VL800490.DBF WHERE CLV=65'

**************************
* vytvorenie connection
**************************************
oConnectionp := SQLConnection():new()
oConnectionpd := SQLConnection():new()
**************************************

* 1.v parameter, window handle, pre zobrazenie dleit
* 2.h parameter, connection string
* 3.t parameter : 
*  SQL_DRIVER_PROMPT - The driver presents a dialog box listing all data sources that have been installed. The user can choose which one to connect to. 
*  SQL_DRIVER_COMPLETE - If the connection string cConnectString contains enough information, the driver will connect to that source; otherwise, a dialog box will be presented to prompt for information. 
*  SQL_DRIVER_COMPLETE_REQUIRED - Behaves like SQL_DRIVER_COMPLETE, except that the driver disables the controls for any information that is not required to connect. 
*  SQL_DRIVER_NOPROMPT 
* 4.ty parameter .T., read only, .F., readwrite

**************************************
* pripojenie ku databze cez driver
***********************************************************************
oConnectionp:driverConnect(nil, @cConnectStringp,SQL_DRIVER_NOPROMPT,.T.)
oConnectionpd:driverConnect(nil, @cConnectStringpd,SQL_DRIVER_NOPROMPT,.T.)
***********************************************************************

*************************************************************************
* kontrola a upozornenie, ak nieje mon vytvori spojenie s databzou
*************************************************************************
if ! oConnectionp:isConnected
*  DC_WinAlert("Pripojenie ku databaze neuspesne !!!")
  Return
else
*  DC_WinAlert("Pripojenie ku databaze uspesne")
endif

**************************************************************************************
* vytvorenie kurzora, bez obmedzenia, tento read only SQL_CONCUR_READ_ONLY a dynamic
**************************************************************************************
*oCursorolp := CreateSQLCursor( oConnectionp, 1, cStatementp )
**********************************************************
* vytvorenie kurzora, bez obmedzenia, tento Scroll Locks  SQL_CONCUR_LOCK a dynamic
**********************************************************
oCursorolp := CreateSQLCursor( oConnectionp, 4, cStatementp )	// OLP
*oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd )	// OLPD - typ 3 s kurzorom problm,lebo blbne listovanie v browseri
*oCursorolpd := CreateSQLCursor( oConnectionp, 2, cStatementpd )	// OLPD - toto funguje dobre,obmedzenie na 1000 zznamov
oCursorolpd := CreateSQLCursor( oConnectionpd, 4, cStatementpd )	// OLPD - toto funguje dobre, obmedzenie na 10000 zznamov
**********************************************************

***********************************************
* asi kontrola i sa podarilo vytvori cursor
***********************************************
*IF Valtype(oCursorolp) # 'O' 	// ak iba OLP
IF Valtype(oCursorolp) # 'O' .or. Valtype(oCursorolpd) # 'O' 	// ak OLP aj OLPD
  RETURN
ENDIF

* tu popis ako odstrani diakritiku
*https://www.interval.cz/clanky/funkce-pro-odstraneni-diakritiky-k-vyhledavani-v-ms-sql/

* zotriedenie poda CLV a PCS
*oCursorolp:Sort({"CLV","PCS"})	// zotriedenie kombinciou pol

* zotriedenie poda VLA - realizuje sa na klient strane !
*oCursorolp:Sort("VLA")	// zotriedenie na klient strane
*oCursorolp:Sort({"VLA"})	// zotriedenie kombinciou pol


*!!!! POZOR !!!!, tu asi nemem poui SEEK, lebo je to kurzor, ktory je na konkrtnom riadku, nutn poui dataset
* vyhadanie SEEK poadovanho mena
*hmeno:="Adam Tibor"

hmeno:="Bilik Jn"
hmeno:=convtoansicp(hmeno)
*hmeno:=convtooemcp(hmeno)

*SET EXACT OFF
*SET LEXICAL ON

*nasiel:=oDataSet:Seek( {val(cisloku),val(cislolv)} )
*nasiel:=oDataSet:Seek(hmeno)	// toto nehad poda diakritiky, ale to ma zatia nezaujma

*nasiel:=oDataSet:Locate( upper(lat_ibm(hmeno)) , {upper(lat_ibm("VLA"))} )	// toto nehad poda diakritiky, ale to ma zatia nezaujma

* skka s codeblokom
*nasiel:=oDataSet:Locate( upper(lat_ibm(hmeno)) , {|o|p:=o:FieldGet("VLA"),upper(lat_ibm(p))} )	// toto nehad poda diakritiky, ale to ma zatia nezaujma

* ukka pouitia codebloku
*nasiel:=oDataSet:Locate( {|o|o:FieldGet(FieldPos("CLV"))=233} )     // custom codeblock

*nasiel:=oDataSet:Locate(233,SQLFieldBlock(oDataset,oDataset:FieldPos("CLV")))
*nasiel:=oDataSet:Locate(233,oDataset:FieldPos("CLV"))

* vyskan pre hadanie poda sla LV -toto z xb2net fra, zaujmav e parametre tu inak nie o a v om a funguje to
*nField := oDataset:FieldPos("CLV")
*nasiel := oDataset:Locate({|aRow,i|aRow[nField]=233})
*nasiel := oDataset:Locate({|aRow,i|aRow[nField]=230})

* skka pre hadanie poda mena
*nField := oDataset:FieldPos("VLA")
*nasiel := oDataset:Locate({|aRow,i|upper(lat_ibm_u(alltrim(aRow[nField])))="BERES ANDREJ"})			// aj toto funguje	
*nasiel := oDataset:Locate({|aRow,i|upper(lat_ibm_u(alltrim(aRow[nField])))=upper(lat_ibm("Bere Andrej"))})	// toto funguje, pozor rzne konverzie !!!

*************************************************************************************************
* Ukka vyhadania vlastnka poda mena, s oetrenm na zadanie aj hadanie s aj bez diakritiky
*************************************************************************************************
/*
* tu u funguje aj pre zadanie s aj bez diakritiky , ale ak chcem filtrova, musm poui Browsefilter alebo SELECT
nField := oDataset:FieldPos("VLA")

hmeno:="Budi Jn"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
*hmeno:=convtooemcp(hmeno)

nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif

hmeno:="Budis Jan"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
*hmeno:=convtooemcp(hmeno)

nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif

hmeno:="BUDIS JAN"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
*hmeno:=convtooemcp(hmeno)

nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif

hmeno:="BUDISS JAN"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
*hmeno:=convtooemcp(hmeno)

nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif
*/

* toto pvodne bolo skan ale vyie je lepie otestovan aj bez diakritiky !!!
/*
* vyhadanie SEEK poadovanho mena
nasiel:=oCursorolp:Seek("%$tenkov%")	// toto nehad poda diakritiky, ale to ma zatia nezaujma

if nasiel
	DC_WinAlert("tenkov Naiel")
else
	DC_WinAlert("tenkov NENaiel")
endif
*/

/* vyhadanie SEEK poadovanho mena
nasiel:=oCursorolp:Seek("%$stenkova%")	// toto nehad poda diakritiky, ale to ma zatia nezaujma

if nasiel
	DC_WinAlert("stenkova Naiel")
else
	DC_WinAlert("stenkova NENaiel")
endif
*/

/*
nasiel:=oCursorolp:Seek("%$Lajtercuk%")	// toto nehad poda diakritiky, ale to ma zatia nezaujma

if nasiel
	DC_WinAlert("Lajtercuk Naiel")
else
	DC_WinAlert("Lajtercuk NENaiel")
endif
*/

/* vyhadanie SEEK poadovanho mena
nasiel:=oCursorolp:Seek("%$Adam Tibor%")	// toto nehad poda diakritiky, ale to ma zatia nezaujma

if nasiel
	DC_WinAlert("Adam Tibor Naiel")
else
	DC_WinAlert("Adam Tibor NENaiel")
endif
*/

****************************************
* Otvorenie databzy pomocou Cursora
****************************************
BROWCURSOR()
****************************************

****************************************
* Otvorenie databzy pomocou Datasetu
****************************************
*BROWDATASET()
****************************************

* ukonenie spojenia z SQL databzoi
oConnectionp:destroy()
oConnectionpd:destroy()

Return


******************************************************
* Ukka otvorenia databzy pomocou oCursoru
******************************************************
FUNCTION BROWCURSOR()
***********************

cp:=1	// iba pomocn slo procesu

* vytvorenie novho cursora s novm triedenm, sksi
*oCursorolp := SQLSelect():new("SELECT * FROM Products ORDER BY Type,Make,Model", oMyConn)
*oCursorolp:Execute()
*oCursorolp:Seek( "Camera" ) // single value/field
*oCursorolp:Seek( {"Camera","Contax","RTS"} ) // multiple values/fields

*cStatementp := 'SELECT C_PROC,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP.DBF ORDER BY C_PROC '
*oCursorolp := CreateSQLCursor( oConnectionp, 1, cStatementp )

* SCOPE code blok
* relcie - zadanie vzieb CPA/VLA
/*
bOLPD:={||OLPD->(DC_SetScope(0,OLP->C_PROC)), ;	// nastav zaiatok v OLPD na slo C_PROC aktulne nastaven v OLP
         OLPD->(DC_SetScope(1,OLP->C_PROC)), ; // nastav koniec v OLPD na slo C_PROC aktulne nastaven v OLP
         OLPD->(DC_DbGoTop()), ;
         oBrowsed:refreshAll()}
*/

* pokus 1
/*
bOLPD:={||(DC_SetScope(0,{oCursorolp:fieldGet(1)})), ;
          (DC_SetScope(1,{oCursorolp:fieldGet(1)})), ;
          ({oCursorolpd:GoTop()}), ;
           {oCursorolpd:refresh()}}
*/


* ukky ako pracova s poom v databze cez fieldget :
*x:=oCursorolp:fieldGet(1)
*y:={x}

*dc_msgbox({oCursorolp:fieldGet(1)})	// toto zobraz obsah poa	- ok
*dc_msgbox({(oCursorolp:fieldGet(1))+1})	// toto zobraz obsah poa aj s inkrementciou - ok
*dc_msgbox({str(oCursorolp:fieldGet(1))})	// toto zobraz obsah poa aj s prevodom na reazec - ok
*dc_msgbox({"C_PROC="+str(oCursorolp:fieldGet(1))})	// toto zobraz obsah poa aj s prevodom na reazec + pridan text - ok
*dc_msgbox(x)				// toto NEzobraz obsah poa !!! NEROZUMIEM, preo, o je to ? 
*dc_msgbox(y)				// toto zobraz ok
*dc_msgbox(alltrim(str({x})))		// toto NEzobraz obsah poa , navye chyba wrong data type
*dc_msgbox({x})				// toto zobraz obsah poa - ok
*dc_msgbox({x+1})			// toto zobraz obsah poa aj s inkrementciou - ok
*dc_msgbox({alltrim(str(x))})		// toto zobraz obsah poa - ok
*dc_msgbox({"C_PROC="+alltrim(str(x))})	// toto zobraz obsah poa - ok


* pomocn code block pre zistenie sla a pouitie do statementu
******************************************************
*bcislo:={||alltrim(str(cislo:=oCursorolp:fieldGet(1)))}	// tu pomocn code block pre zmenu z ztvorkovho na normlny tvar aby sa dalo alej spracova normlne
******************************************************
*dc_msgbox(eval(bcislo))		// toto zobraz OK
*ladenie(y[1])				// no, y je pole array, a prvok je v y[1]
*ladenie(x)				// no, zobraz ok
*ladenie(eval(bcislo))			// no, zobraz ok


** fixne slo 3 - funguje
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+(alltrim(str(3)))+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD

** slo 3 uloen v premennej cislo - funguje
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+(alltrim(str(cislo)))+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD

** cislo uloen do code bloku bcislo1 - funguje
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+eval(bcislo1)+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD

** cislo zisten z OLP cez fieldget a code blok bcislo2
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+{str(oCursorolp:fieldget(1))}+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+{str(oCursorolp:fieldget(1))}+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD


* TU POKUS 1 - definovanie statementu pre variabilny parameter fieldget
*fixne 3
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+alltrim(str(3))+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD


* TUTUTU
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC=RAUKN_OLP.C_PROC AND RAUKN_OLP_D.C_PROC='+eval(bcislo)+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC='+eval(bcislo)+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD

*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+eval(bcislo)+' ORDER BY C_PROC '	 // OLPD

*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF,RAUKN_OLP WHERE RAUKN_OLP_D.C_PROC='+{alltrim(str(cislo))}+' ORDER BY RAUKN_OLP_D.C_PROC '	 // OLPD

/*
bOLPD:={||;
	  oCursorolpd:Close(), ;
	  oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd ), ;
	  oCursorolpd:refresh(), ;
          oCursorolpd:GoTop() ;
	}
*	  oBrowsed:dataSource:=oCursorolp, ;
*	  oBrowsed:refreshall(), ;
*/

**************************************************************
* skka zatvorenia a otvorenia kurzora s inmi parametrami
**************************************************************
* pvodn statement ktorm vytvoren kurzor hore 
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF ORDER BY C_PROC '	 // OLPD

* pre C_PROC 2
*cStatementpd2 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC=2 ORDER BY C_PROC '	 // OLPD
* pre C_PROC 3
*cStatementpd3 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC=3 ORDER BY C_PROC '	 // OLPD
* pre C_PROC = premenn cislo

*cislo="1"
*bcislo:={||(cislo)}


*bcislo:={||alltrim(str(oCursorolp:fieldget(1)))} 


*cStatementpd4 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+cislo+') ORDER BY C_PROC '	 // OLPD
*cStatementpd4 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+(eval(bcislo))+') ORDER BY C_PROC '	 // OLPD
*cStatementpd4 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+'4'+') ORDER BY C_PROC '	 // OLPD

*bstat:={||cStatementpd4 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+cislo+') ORDER BY C_PROC '}
*bstat:={||cStatementpd4 := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+alltrim(str(oCursorolp:fieldGet(1)))+') ORDER BY C_PROC '}

*bstatementd:={||cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+alltrim(str(oCursorolp:fieldGet(1)))+') ORDER BY C_PROC '}
*bstatementd:={||cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+(eval(bcislo))+') ORDER BY C_PROC '}

/* zatvorenie pvodnho kurzora
oCursorolpd:close()
* otvorenie novho kurzora pre cislo 2
oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd2 )
oCursorolpd:refresh()
oCursorolpd:GoTop()
*/

/* zatvorenie kurzora pre 2 a otvorenie kurzora pre 3
oCursorolpd:close()
* otvorenie novho kurzora pre cislo 3
oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd3 )
oCursorolpd:refresh()
oCursorolpd:GoTop()
*/

/*
* zatvorenie kurzora pre 3 a otvorenie kurzora pre premennu cislo 
*cislo:=alltrim(str(4))
cislo:="4"
eval(bstat)
oCursorolpd:close()
* otvorenie novho kurzora pre cislo 4
oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd4 )
oCursorolpd:refresh()
oCursorolpd:GoTop()
*/

/*
* skka so zadanm viazanej podmienky na OLP cez C_PROC z  fieldget 
bcislo:={||alltrim(str(cislo:=oCursorolp:fieldGet(1)))}		// ako reazec
bcislon:={||((cislo:=oCursorolp:fieldGet(1)))}			// ako slo	
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+eval(bcislo)+' ORDER BY C_PROC '	 // OLPD
*/


/*
bOLPD:={||eval(bcislo),;
	  oCursorolpd:Close(),;
	  oCursorolpd := CreateSQLCursor( oConnectionp, 3, cStatementpd ),;
          oCursorolpd:refresh()}
*         oCursorolpd:GoTop(), ;
*/

/*
* toto z tlatka v toolbare, ktor funguje, teraz prerobi na codeblock pre scope
* s tou verziou zobraz iba jeden zznam
bOLPD:={|pomcislo1,pomcislo2|;
	pomcislo1:={oCursorolp:fieldget(1)},;			// ako slo
	pomcislo2:=alltrim(str(oCursorolp:fieldget(1))),;	// ako text
	cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+(pomcislo2)+' ORDER BY C_PROC ',;
	oCursorolpd:close(),;
	oCursorolpd := CreateSQLCursor( oConnectionpd, 4, cStatementpd ),;
	oCursorolpd:GoTop(),;
	oBrowsed:refreshall(),;
	DC_GETREFRESH(GETLIST),tone(200,1) ; // refresh prostredia
	}
*

* zatia przdny code blok
bOLPD:={||nil}
*/

* skam vytvori dataset , a nie cez CreateSQLCursor
bOLPD:={|pomcislo1,pomcislo2|;
	pomcislo1:={oCursorolp:fieldget(1)},;			// ako slo
	pomcislo2:=alltrim(str(oCursorolp:fieldget(1))),;	// ako text
	cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+(pomcislo2)+' ORDER BY C_PROC ',;
	oCursorolpd:close(),;
	oCursorolpd := CreateSQLCursor( oConnectionpd, 4, cStatementpd ),;
	oBrowsed:refreshall(),;
	oCursorolpd:GoTop(),;
	DC_GETREFRESH(GETLIST),tone(200,1) ; // refresh prostredia
	}
*	oCursorolpd:close(),;

*oCursorolp:seek(2)
*oCursorolpd:seek(2)

* TOTO SKڊAM TERAZ SPOJAZDNI
*bcislo:={||alltrim(str(oCursorolp:fieldget(1)))} 
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+eval(bcislo)+' ORDER BY C_PROC '	 // OLPD
*bstatementd:={||cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+(eval(bcislo))+') ORDER BY C_PROC '}


* tu iba aby boli poruke pre porovnanie
* OLP *
*cStatementp := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP.DBF ORDER BY C_PROC '	 // OLP
* OLPD *
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF ORDER BY C_PROC '	 // OLPD
* OLPD * Filtrovan pre C_PROC
*cStatementpd := 'SELECT RAUKN_OLP_D.C_PROC,RAUKN_OLP_D.DAVKA,RAUKN_OLP_D.DAT_ZAD,RAUKN_OLP_D.CAS_ZAD,RAUKN_OLP_D.STAV,RAUKN_OLP_D.NAZPTK FROM RAUKN_OLP_D.DBF WHERE RAUKN_OLP_D.C_PROC='+(pomcislo2)+' ORDER BY C_PROC ',;
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+(pomcislo2)+' ORDER BY C_PROC ',;

*************************
* BROWSE TABUKA PRE OLP
*************************
DCSETPARENT oBrowse

@ 0,0 DCBROWSE oBrowse ALIAS "OLP" DATA oCursorolp ;	
	SIZE 150,15 ;
	PRESENTATION DC_BrowPres() ;
        CURSORMODE XBPBRW_CURSOR_ROW ; 
        ITEMMARKED {||Eval(bOLPD), ;
        DC_GetRefresh(GetList,, ;
        DCGETREFRESH_TYPE_EXCLUDE,(GETLIST_BROWSE))} 
*	SCOPE ;

/*
* automatick vygenerovanie pol , ale to nechcem, lebo chcem vlastn popisy hlaviiek
FOR i := 1 TO oCursorolp:fCount
  DCBROWSECOL DATA SQLFieldBlock( oCursorolp, i ) ;
      HEADER oCursorolp:fieldName(i) ;
      SORT SQLSortBlock( oCursorolp, i ) ;
        _DEFAULT oCursorolp:fieldName(i) == 'C_PROC' ;
SIZE 150,20 ;
      PARENT oBrowse
NEXT
*/

* pre databzu RAUKN_OLP

        DCSETPARENT oBrowse

*tu pvodn variant s SQLFieldBlock
************************************
*
	* tu zobraz ak je zznam zruen	
*	DCBROWSECOL DATA {|x|x:=deleted(),IIF(x,'X',' ')} ;
*	  HEADER "Zru" WIDTH 5 PARENT oBrowse

	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("C_PROC")) ;	// ozn. registra
		HEADER "C_PROC"   WIDTH 10 PARENT oBrowse

	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("DAVKA")) ;	// ozn. registra
		HEADER "DAVKA"   WIDTH 10 PARENT oBrowse

	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("DAT_ZAD")) ;	// ozn. registra
		HEADER "DAT_ZAD"   WIDTH 10 PARENT oBrowse

	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("CAS_ZAD")) ;	// ozn. registra
		HEADER "CAS_ZAD"   WIDTH 20 PARENT oBrowse
			
	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("STAV")) ;	// ozn. registra
		HEADER "STAV"   WIDTH 5 PARENT oBrowse

	DCBROWSECOL DATA SQLFieldBlock(oCursorolp,oCursorolp:FieldPos("NAZPTK")) ;	// ozn. registra
		HEADER "NAZPTK"   WIDTH 10 PARENT oBrowse
*

*tu prava bez SQLFieldBlock
****************************
/*
	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("C_PROC"))} ;	// ozn. registra
		HEADER "C_PROC"   WIDTH 10 PARENT oBrowse 

	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("DAVKA"))} ;	// ozn. registra
		HEADER "DAVKA"   WIDTH 10 PARENT oBrowse 

	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("DAT_ZAD"))} ;	// ozn. registra
		HEADER "DAT_ZAD"   WIDTH 10 PARENT oBrowse 

	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("CAS_ZAD"))} ;	// ozn. registra
		HEADER "CAS_ZAD"   WIDTH 20 PARENT oBrowse 
			
	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("STAV"))} ;	// ozn. registra
		HEADER "STAV"   WIDTH 5 PARENT oBrowse 

	DCBROWSECOL DATA {||oCursorolp:fieldget(oCursorolp:FieldPos("NAZPTK"))} ;	// ozn. registra
		HEADER "NAZPTK"   WIDTH 10 PARENT oBrowse  
*/

*************************
* BROWSE TABUKA PRE OLPD
*************************
DCSETPARENT TO oBrowsed

@ 22,0 DCBROWSE oBrowsed ALIAS "OLPD" DATA oCursorolpd ;
	SIZE 150,15 ;
	PRESENTATION DC_BrowPres() ;
        CURSORMODE XBPBRW_CURSOR_ROW ; 
	ITEMMARKED {|| ;
        DC_GetRefresh(GetList,, ;
        DCGETREFRESH_TYPE_EXCLUDE,(GETLIST_BROWSE))} 
*	SCOPE 

/*
* toto zobraz ok , ale tie iba jeden riadok z datasetu
*
* automatick vygenerovanie pol , ale to nechcem, lebo chcem vlastn popisy hlaviiek
*FOR i := 1 TO oCursorolpd:fCount()
FOR i := 1 TO 6
*  DCBROWSECOL DATA SQLFieldBlock( oCursorolp, i ) ;
*  DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("C_PROC"))} ;
  DCBROWSECOL DATA {||oCursorolpd:fieldget(i)} ;
      	HEADER oCursorolpd:fieldName(i) ;
      	PARENT oBrowsed 
*      	SORT SQLSortBlock( oCursorolpd, i ) ;
*        _DEFAULT oCursorolpd:fieldName(i) == 'C_PROC' 
*	SIZE 150,15 ;	// toto nie, lebo hlsi chybu
NEXT
*/

/*
* automatick vygenerovanie pol , ale to nechcem, lebo chcem vlastn popisy hlaviiek
pocetriadkov:=oCursorolpd:reccount()
if oCursorolpd:reccount()!=-1			// kontrola i existuj zznamy
	*FOR j := 1 TO oCursorolpd:reccount()	// cyklus riadkov ak -1 tak nenaiel
	*FOR i := 1 TO oCursorolpd:fcount()	// cyklus stpcov
	oCursorolpd:GoTop()			// skok na zaiatok, tu pre istotu ale u je niekde v bloku hore
*	do while !oCursorolpd:bof()		// nedobre vyhodnocuje
	do while oCursorolpd:recno()<=pocetriadkov	
		FOR i := 1 TO 6	// cyklus stpcov
		*FOR i := 1 TO oCursorolpd:fcount()	// cyklus stpcov
			DCBROWSECOL DATA {||oCursorolpd:fieldget(i,j)} ;		// fieldget(xColumn,[nRow])
			      	PARENT oBrowsed ;
		      		HEADER oCursorolpd:fieldName(i) 
	*      SORT SQLSortBlock( oCursorolpd, i ) ;
	*        _DEFAULT oCursorolpd:fieldName(i) == 'C_PROC' 
	*	SIZE 150,15 ;	// toto nie, lebo hlsi chybu
		NEXT
		ocursorolpd:skip(1)
	enddo
	*NEXT 
endif
*/

* pre databzu RAUKN_OLP_D

	DCSETPARENT TO oBrowsed

*tu pvodn variant s SQLFieldBlock
************************************
/*
	* tu zobraz ak je zznam zruen	
*	DCBROWSECOL DATA {|x|x:=deleted(),IIF(x,'X',' ')} ;
*	  HEADER "Zru" WIDTH 5 PARENT oBrowsed

	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("C_PROC")) ;	// ozn. registra
		HEADER "C_PROC"   WIDTH 10 PARENT oBrowsed

	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("DAVKA")) ;	// ozn. registra
		HEADER "DAVKA"   WIDTH 10 PARENT oBrowsed

	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("DAT_ZAD")) ;	// ozn. registra
		HEADER "DAT_ZAD"   WIDTH 10 PARENT oBrowsed

	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("CAS_ZAD")) ;	// ozn. registra
		HEADER "CAS_ZAD"   WIDTH 20 PARENT oBrowsed
			
	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("STAV")) ;	// ozn. registra
		HEADER "STAV"   WIDTH 5 PARENT oBrowsed

	DCBROWSECOL DATA SQLFieldBlock(oCursorolpd,oCursorolpd:FieldPos("NAZPTK")) ;	// ozn. registra
		HEADER "NAZPTK"   WIDTH 10 PARENT oBrowsed
*/

*tu prava bez SQLFieldBlock
****************************
*
	* tu ako zobrazi prv stpec pomocou recordget
	*DCBROWSECOL DATA {|q|q:=oCursorolpd:recordget(oCursorolpd:FieldPos("C_PROC")),q[1]} ;	// ozn. registra
	*	HEADER "C_PROC*1"   WIDTH 10 PARENT oBrowsed 

	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("C_PROC"))} ;	// ozn. registra
		HEADER "C_PROC"   WIDTH 10 PARENT oBrowsed 

	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("DAVKA"))} ;	// ozn. registra
		HEADER "DAVKA"   WIDTH 10 PARENT oBrowsed 

	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("DAT_ZAD"))} ;	// ozn. registra
		HEADER "DAT_ZAD"   WIDTH 10 PARENT oBrowsed 

	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("CAS_ZAD"))} ;	// ozn. registra
		HEADER "CAS_ZAD"   WIDTH 20 PARENT oBrowsed 
			
	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("STAV"))} ;	// ozn. registra
		HEADER "STAV"   WIDTH 5 PARENT oBrowsed 

	DCBROWSECOL DATA {||oCursorolpd:fieldget(oCursorolpd:FieldPos("NAZPTK"))} ;	// ozn. registra
		HEADER "NAZPTK"   WIDTH 10 PARENT oBrowsed  
*

        DCSETPARENT oToolbarplb

	***********************
	* zobrazenie toolbaru
	***********************
	@ 0,160 DCTOOLBAR oToolbarplb SIZE 22,70 ;
              ALIGN DCGUI_ALIGN_LEFT ;
              BUTTONSIZE 20,1.5 ;
              SPACE 2 ;
              RESIZE DCGUI_RESIZE_REPOSONLY_X ;
              FIT

	* refresh kurzora - funguje, aj ke pridm cez RAUKN
	* pre Cursor namiesto FetchData poui Refresh, Sort tie nepozn, mus asi server alebo statement na zaiatku definova
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia
*			oCursorolp:Gotop(),;			// skok na zaiatok toto tu asi netreba 

	* skok na zaiatok - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'GOTOP';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Gotop(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* skok na koniec - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'GOBOTTOM';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Gobottom(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* vyhadanie isla 3 - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SEEK-OLP-3' ;
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Seek({3}),;			// triedenie poda C_PROC
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* vyhadanie isla 3 v OLPD - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SEEK-OLPD-3' ;
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:Seek({3}),;			// triedenie poda C_PROC
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* vyhadanie isla 3 - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SEEK-OLP-3' ;
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Seek(3),;			// triedenie poda C_PROC
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* vyhadanie isla 3 v OLPD - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SEEK-OLPD-3' ;
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:Seek(3),;			// triedenie poda C_PROC
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* pridanie przdneho riadku a zadanie dajov - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'PRIDAJ 999-A';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Append(),;
			oCursorolp:FieldPut("C_PROC", cp++ ),;	// inkrementlne pridva vdy nasledujce slo procesu ale to iba test, inak musm zisti nasledujce inak nie recno
			oCursorolp:FieldPut("DAT_ZAD", date() ),;
			oCursorolp:FieldPut("CAS_ZAD", time() ),;
			oCursorolp:FieldPut("NAZPTK", "PROTOKOL-A" ),;
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:Gobottom(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* pridanie przdneho riadku a zadanie dajov - pridvanie s inkrementovanm por.sla - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'PRIDAJ 999-INCR';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Gobottom(),;			// skok na koniec
			maxc:=oCursorolp:FieldGet("C_PROC"),;	// zistenie poslednho sla
			maxc++,;				// inkrementovanie	
			oCursorolp:Append(),;			// pridanie przneho zznamu
			oCursorolp:FieldPut("C_PROC", maxc ),;	// zadanie obsahu pol
			oCursorolp:FieldPut("DAT_ZAD", date() ),;
			oCursorolp:FieldPut("CAS_ZAD", time() ),;
			oCursorolp:FieldPut("NAZPTK", "PROTOKOL-A" ),;
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:Gobottom(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia


	* pridanie przdneho riadku a zadanie dajov - naraz vetky daje v riadku - NEFUNGUJE , neviem presn syntax
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'PRIDAJ 999-B';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Append({55,date(),"-","-",0,.F.,date(),"-",0,.F.,.F.,.F.,0,0,"-","-","-","-",0,0,"-",0,0,date(),date(),0,0,0,"-","-",0,0,.F.,"-","-","-","-","-",.F.,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"-",0,"-","-",0}), ;
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* aktualizcia dajov v riadku - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'UPRAV STAV 0';
       	   ACTION {|| ;					// neviem o rob, asi iba ta stavy 
			oCursorolp:FieldPut("STAV",0),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* aktualizcia dajov v riadku - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'UPRAV STAV 1';
       	   ACTION {|| ;					// neviem o rob, asi iba ta stavy 
			oCursorolp:FieldPut("STAV",1),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* aktualizcia dajov v riadku - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'UPRAV STAV 2';
       	   ACTION {|| ;					// neviem o rob, asi iba ta stavy 
			oCursorolp:FieldPut("STAV",2),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:UpdateRow(),;
			oCursorolp:Refresh(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* vymazanie riadku - funguje 
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'VYMA';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolp:Delete(),;			// znovunatanie databzy, refresh datasetu
			oCursorolp:UpdateRow(),;			// toto asi mus by
			oCursorolp:skip(),;			// ? mono nemus by
			oCursorolp:Refresh(),; 			// refresh
			oCursorolp:gobottom(),; 			// skok na koniec
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* zisti slo C_PROC nastavenho riadku v OLP
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'C_PROC-OLP';
       	   ACTION {||   dc_msgbox({oCursorolp:fieldget(1)}) ;
			}

	* zisti slo C_PROC nastavenho riadku v OLPD
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'C_PROC-OLPD';
       	   ACTION {||   dc_msgbox({oCursorolpd:fieldget(1)});
			}

	* zisti slo C_PROC nastavenho riadku v OLP a sko na to slo v OLPD - funguje ak je zkladn statement
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'OLP skok OLPD';
       	   ACTION {|pomcislo|pomcislo:={oCursorolp:fieldget(1)},dc_msgbox(pomcislo), ;	// zobrazenie na ktoromje v OLP
			oCursorolpd:Seek(pomcislo),;		// skok na C_PROC na ktorom je v OLP 
			dc_msgbox({oCursorolp:fieldget(1)}),;	// zobrazenie na ktor zznam skoil v OLPD	 
			oBrowsed:refreshall(),;			// !!! refresh browsera , bez toho ostane na pvodnej pozcii 	
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* refresh OLPD - funguje, ale pre aktualizciu ak sa na sieti nieo zmenilo treba asi aj oCursorolp:refresh()
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH-OLP';
       	   ACTION {||   ;
			oBrowse:refreshall(),;
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* refresh OLPD - funguje, ale pre aktualizciu ak sa na sieti nieo zmenilo treba asi aj oCursorolp:refresh()
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH-OLPD';
       	   ACTION {||   ;
			oBrowsed:Refreshall(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia


*toto skam spojazdni
	* refresh OLPD
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH-OLPD-FILTER1' ;
       	   ACTION {|pomcislo|pomcislo:=eval(bcislo),dc_msgbox(pomcislo),cStatementpd:=eval(bstatementd),ladenie(cStatementpd), ; // vytvor nov statement
			oCursorolpd:close(),;						// zatvor pvodn kursor a pok sekundu
			oCursorolpd := CreateSQLCursor( oConnectionp, 4, cStatementpd ),;	// otvor nov kurzor s novm statementom
			oCursorolpd:Seek(val(pomcislo)),;					// sko na
			oCursorolpd:gotop(),;
			oBrowsed:refreshall(),;
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

*bcislo:={||alltrim(str(oCursorolp:fieldget(1)))} 
*cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE C_PROC='+eval(bcislo)+' ORDER BY C_PROC '	 // OLPD
*bstatementd:={||cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+(eval(bcislo))+') ORDER BY C_PROC '}

	* refresh OLPD - verzia ak tu priamo zadefinovan statement
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH-OLPD+FILTER2';
       	   ACTION {|pomcislo1,pomcislo2|;
			pomcislo1:={oCursorolp:fieldget(1)},;			// ako slo
		    	pomcislo2:=alltrim(str(oCursorolp:fieldget(1))),;	// ako text
			dc_msgbox(pomcislo1),;
			dc_msgbox(pomcislo2),;
			cStatementpd := 'SELECT C_PROC,DAVKA,DAT_ZAD,CAS_ZAD,STAV,NAZPTK FROM RAUKN_OLP_D.DBF WHERE (C_PROC='+pomcislo2+') ORDER BY C_PROC ',;
			ladenie(cStatementpd),;
			oCursorolpd:close(),;
			oCursorolpd := CreateSQLCursor( oConnectionp, 4, cStatementpd ),;
			oBrowsed:refreshall(),;
			DC_GETREFRESH(GETLIST),tone(200,1) ; // refresh prostredia
			}

*			oCursorolpd:Seek(pomcislo1),;
*			dc_msgbox({oCursorolpd:fieldget(1)}),;				// iba skam ak slo uke po refreshi
*			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* refresh OLPD - funguje, ale pre aktualizciu ak sa na sieti nieo zmenilo treba asi aj oCursorolp:refresh()
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'EVAL(BOLPD)';
       	   ACTION {||   eval(bolpd),;
			oBrowsed:Refreshall(),;			// znovunatanie databzy, refresh datasetu
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

	* refresh OLPD - funguje, ale pre aktualizciu ak sa na sieti nieo zmenilo treba asi aj oCursorolp:refresh()
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'RECCOUNT OLPD)';
       	   ACTION {||   ladenie(oCursorolpd:reccount()),;
			ocursorolpd:gotop(),;
			oBrowsed:RefreshAll();
			 } // refresh prostredia

	* skok na zaiatok - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'GOTOP-OLPD';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:Gotop(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* skok na koniec - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'GOBOTTOM-OLPD';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:Gobottom(),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* skok na koniec - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SKIP +1-OLPD';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:skip(1),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia

	* skok na koniec - funguje
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'SKIP -1-OLPD';
       	   ACTION {|| ;						// neviem o rob, asi iba ta stavy 
			oCursorolpd:skip(-1),;			// skok na zaiatok
			DC_GETREFRESH(GETLIST),tone(200,1) } 	// refresh prostredia


* tu u samotn zobrazenie BROWSERom
DCGETOPTIONS ;
   AUTORESIZE ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   BUTTONS DCGUI_BUTTON_EXIT ;
   TITLE 'Browsing with SQLexpress - pouit oCursorolp' ;
   EVAL {|o|SetAppWindow(o), ;
	SetAppFocus(oBrowse:GetColumn(1));
	} 

*qqq vyradzujem
*	oCursorolpd:gotop();

*   EVAL {|o|SetAppWindow(o), ;
*	SetAppFocus(oBrowse:GetColumn(1));
*	} 
*oBrowsed:dataSource:=oCursorolp,oBrowsed:refreshAll();
*	SetAppFocus(oBrowse:GetColumn(1));

* zatvorenie cursoru a uvonenie pamti
oCursorolp:Close()
oCursorolpd:Close()

RETURN NIL


******************************************************
* Ukka otvorenia databzy pomocou oDatasetu
******************************************************
FUNCTION BROWDATASET()
*************************
* vytvorenie datasetu 		// tento otvram a po ukke otvorenia oCursoru
*************************
* toto funguje, ale ku ku musm prida percento ako wildcard
*hmeno:="Budi Jn%"
*hmeno:="Adam%"
*cStatementp := 'SELECT CLV,PCS,VLA FROM VL800490.DBF WHERE VLA LIKE "'+hmeno+'" ORDER BY VLA'	// toto funguje

* toto funguje, a u ku ku netreba wildcard, ale zatia bez oetrenia na diakritiku
*hmeno:="Budi Jn"
*hmeno:="Adam"
*cStatementp := 'SELECT CLV,PCS,VLA FROM VL800490.DBF WHERE VLA LIKE "'+hmeno+'%" ORDER BY VLA'	// toto funguje , a u nemusm dva wildcard percento ku ku

* tu skam prida oetrenie na diakritiku
*hmeno:="Budi Jn"
*hmeno:="BUDIS JAN"
hmeno:="Adam"
*hmeno:="ADAM"
*hmeno:="adam"

* toto nefunguje, resp. neviem, ako odstrni pri porovnan diakritiku z poa VLA !!!
*cStatementp := 'SELECT CLV,PCS,VLA FROM VL800490.DBF WHERE upper(lat_ibm_u(alltrim("VLA"))) LIKE "'+hmeno+'%" ORDER BY VLA'
*cStatementp := 'SELECT CLV,PCS,VLA FROM VL800490.DBF WHERE UPPER(VLA) LIKE "'+hmeno+'%" ORDER BY VLA'


*cStatementp := 'SELECT CLV,PCS,VLA,upper(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran('+;
*		'strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(VLA, "", "a")'+;
*		', "", "c"), "", "d"), "", "e"), "", "e"), "", "i"), "", "l"), "", "n"), "", "o"'+;
*		'), "", "r"), "", "s"), "", "t"), "", "u"), "", "u"), "", "y"), "", "z"), "", "a"'+;
*		'), "", "o"), "", "u")) AS VLAU FROM VL800490.DBF INTO POKUS SELECT * FROM POKUS '

* WHERE VLAU LIKE "'+hmeno+'%" 

* toto funguje, 4te pole je upper bez diakritiky
* pre databzu VL800490
/*
cStatementp := 'SELECT CLV,PCS,VLA,upper(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran('+;
		'strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(strtran(VLA, "", "a")'+;
		', "", "c"), "", "d"), "", "e"), "", "e"), "", "i"), "", "l"), "", "n"), "", "o"'+;
		'), "", "r"), "", "s"), "", "t"), "", "u"), "", "u"), "", "y"), "", "z"), "", "a"'+;
		'), "", "o"), "", "u")) AS VLAU FROM VL800490.DBF '
*/

* pre databzu RAUKN_OLP
cStatementp := 'SELECT C_PROC,DAT_ZAD,CAS_ZAD,NAZPTK FROM RAUKN_OLP.DBF '

*cStatementp := 'SELECT CLV,PCS,VLA,upper(VLA) AS VLAU FROM VL800490.DBF'
*cStatementp := 'SELECT CLV,PCS,VLA,(SELECT upper(VLA) FROM VL800490.DBF) AS VLAU FROM VL800490.DBF'

*!!! zbyton snaha ODBC VFP6 nepozn alias AS, take asi aj ostatn prkazy
* musm riei ako rad roger

*SET COLLATION TO ASCII
oDataSet := oConnectionp:DataSet(cStatementp,,,,,,,,.T.) 
*SET COLLATION TO SYSTEM

* pre databazu VL800490
*oDataSet:Sort("VLA")

* pre databzu RAUKN_OLP
oDataSet:Sort("C_PROC")
oDataSet:Gotop()

*pocetzaznamov:=oDataSet:RecCount()
*oDataset:GoTop()
*DC_WinAlert("Poet natanch zznamov :"+str(pocetzaznamov))

/*
* skka vyhadania cez Locate
nField := oDataset:FieldPos("VLA")
hmeno:="Budi Jn"
hmenoz:=convtoansicp(hmeno)	// toto len pre zobrazenie
*hmeno:=convtooemcp(hmeno)
nasiel := oDataset:Locate({|aRow,i|like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) ) })	// toto funguje, pozor rzne konverzie !!!
															// tu aj hviezdikov konvencia
if nasiel
	DC_WinAlert(hmenoz+" Naiel")
else
	DC_WinAlert(hmenoz+" NENaiel")
endif

* skka odfiltrovania
bdataset:={||oDataset:Browsefilter:={|aRow,nRow,oData| like ( upper(lat_ibm(hmeno))+"*" , upper(lat_ibm_u(alltrim(aRow[nField]))) )}}
*eval(bdataset)
*/

*DCGETOPTIONS ;
*	AUTORESIZE ;
*	BUTTONALIGN DCGUI_BUTTONALIGN_CENTER


* zobrazenie tabuky v browseri - njden plomby ale neodfiltrovan
********************************
@ 0,0 DCBROWSE oBrowseds DATA oDataSet ;  
           SIZE 150,20 ;
	   PRESENTATION DC_BrowPres() 
*	   FILTER {|a|a:=oDataset:FieldPos("CLV"),a = 233}		// tu musm nejak upravi aby spracovvalo cez code block obsah poa look plomby
*	   FILTER {||like("Adam*",VLA)}
*	   FILTER {||like(upper(lat_ibm(hmeno))+"*",VLAU)}
*	   FILTER {||(CLV) > 200}
*	   FILTER {||UPPER(VLA) LIKE "'+hmeno+'%"}
*	   FILTER {|a|'.DBF'$Upper(a[1])}

	* generovanie zoznamu pol - upraven, aby som zadal header ako ja chcem
	*DCBROWSECOL DATA SQLFieldBlock(oDataset,1) ;				// por.slo viem zisti cez FieldPos, ale por.. stpca !!!

*	DCBROWSECOL DATA {||oDataset:RecNo()} ;				// poradov slo v zozname plomb
*		HEADER "Por.."   WIDTH 8 PARENT oBrowseds

* pre databzu VL800490
/*
	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("CLV")) ;	// ozn. registra
		HEADER "CLV"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("PCS")) ;	// ozn. registra
		HEADER "PCS"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("VLA")) ;	// ozn. registra
		HEADER "VLA"   WIDTH 50 PARENT oBrowseds
			
	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("VLAU")) ;	// ozn. registra
		HEADER "VLAU"   WIDTH 50 PARENT oBrowseds
*/

* pre databzu RAUKN_OLP
	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("C_PROC")) ;	// ozn. registra
		HEADER "C_PROC"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("DAT_ZAD")) ;	// ozn. registra
		HEADER "DAT_ZAD"   WIDTH 10 PARENT oBrowseds

	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("CAS_ZAD")) ;	// ozn. registra
		HEADER "CAS_ZAD"   WIDTH 20 PARENT oBrowseds
			
	DCBROWSECOL DATA SQLFieldBlock(oDataset,oDataset:FieldPos("NAZPTK")) ;	// ozn. registra
		HEADER "NAZPTK"   WIDTH 20 PARENT oBrowseds


	* toolbar zatia vyradzujem, netreba, ale potom ak aktivujem nastavi pozciu
	*
        DCSETPARENT oToolbarplb
	*
	@ 0,160 DCTOOLBAR oToolbarplb SIZE 22,70 ;
              ALIGN DCGUI_ALIGN_LEFT ;
              BUTTONSIZE 20,2 ;
              SPACE 5 ;
              RESIZE DCGUI_RESIZE_REPOSONLY_X ;
              FIT

	*******************************************************************************************
	* skka ako spravi refresh dt aj ke mm Dataset - aj cez VPN sprav za cca 4 sekundy !!
	*******************************************************************************************
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'REFRESH';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;		// neviem o rob, asi iba ta stavy 
			oDataset:FetchData(),;			// znovunatanie databzy, refresh datasetu
			oDataSet:Sort("C_PROC"),;		// triedenie poda C_PROC
			oDataSet:Gotop(),;			// skok na zaiatok
			oDataset:gobottom(),; 			// skok na koniec
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'PRIDAJ';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;		// neviem o rob, asi iba ta stavy 
			oDataset:FetchData(),;			// znovunatanie databzy, refresh datasetu
			oDataSet:Sort("C_PROC"),;		// triedenie poda C_PROC
			oDataSet:Gotop(),;			// skok na zaiatok
			oDataset:gobottom(),; 			// skok na koniec
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'UPRAV';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;		// neviem o rob, asi iba ta stavy 
			oDataset:FetchData(),;			// znovunatanie databzy, refresh datasetu
			oDataSet:Sort("C_PROC"),;		// triedenie poda C_PROC
			oDataSet:Gotop(),;			// skok na zaiatok
			oDataset:gobottom(),; 			// skok na koniec
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia

       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'VYMA';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;		// neviem o rob, asi iba ta stavy 
			oDataset:FetchData(),;			// znovunatanie databzy, refresh datasetu
			oDataSet:Sort("C_PROC"),;		// triedenie poda C_PROC
			oDataSet:Gotop(),;			// skok na zaiatok
			oDataset:gobottom(),; 			// skok na koniec
			DC_GETREFRESH(GETLIST),tone(200,1) } // refresh prostredia


	* toto zatia vyraden, to iba ak by bolo treba inak riei posuv vpred, vzad, ktor blbol pri plombch
	/*       
       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'DOZADU';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;
               	        IIF(qoDataset:BOF(),;
                       	NIL,qoDataset:SKIP(-1)),DC_GETREFRESH(GETLIST) } ;
       	           WHEN {|| !(qoDataset:BOF()) } TABSTOP

       	DCADDBUTTON PARENT oToolbarplb ;
           CAPTION 'DOPREDU';
       	   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK),;                    
                 	IIF(qoDataset:EOF(),;
			NIL,qoDataset:SKIP(1)),DC_GetRefresh(Getlist) } ;
           WHEN {|| !(qoDataset:EOF()) } TABSTOP
	*/	

	* tu u samotn zobrazenie BROWSERom
	/*
	DCGETOPTIONS PIXEL;
        	TABSTOP AUTORESIZE ;
	        SAYWIDTH 0 ;
		FONT fontnt ;
		HILITEGETS GRA_CLR_BLUE ;
		SCROLLBARS XBP_SCROLLBAR_VERT ;
		BUTTONALIGN DCGUI_BUTTONALIGN_CENTER
*	        WINDOWCOL pozxplb-15 ;
*	        WINDOWROW pozyplb-15 ;
*        	WINDOWWIDTH rozxplb+30 ;
*	        WINDOWHEIGHT rozyplb+30 ;	
	*/	

	* toto ako hore pouit	
	*
	DCREAD GUI ;
	   FIT ;
	   OPTIONS GetOptions ;
	   BUTTONS DCGUI_BUTTON_EXIT ;
	   TITLE 'Browsing with SQLexpress - pouit oDataSet' ;
		EVAL {|o|SetAppWindow(o) }
	
*			Eval(bdataset);	

	* toto ako mm v RAUKN pre plomby
	/*
	DCREAD GUI CLEAREVENTS FIT ;
		MODAL ;
		OPTIONS GetOptions ;
		BUTTONS DCGUI_BUTTON_EXIT ;
		TITLE 'Zobrazenie njdench plomb' ;
		EVAL {|o|SetAppWindow(o), ;
			oDataset:GoTop();	
			}
	*/

*zatvorenie datasetu
oDataset:Close()
*

RETURN NIL


* POZOR, tieto funkcie s zo Samples ku eXpress++ Roger, ale
* v SQL Express++ je funkcia in, zloitejia 
******************************************************************
STATIC FUNCTION CreateSQLCursor( oConnection, nMode, cStatement )
******************************************************************

* typy kurzora, pvodne tu v tomto prklade bol SQL_CONCUR_READ_ONLY
*Read-Only  (SQL_CONCUR_READ_ONLY):
*Optimistic with Values (SQL_CONCUR_VALUES):
*Optimistic with Row Versioning (SQL_CONCUR_ROWVER):
*Scroll Locks  (SQL_CONCUR_LOCK):

Local oCursor, nSuccess := SQL_XPP_ERROR

oConnection:displayErrors := .t.

DEFAULT nMode := 1

if nMode == 1
  oCursor  := SQLSelect():new(cStatement, oConnection, SQL_CONCUR_READ_ONLY, SQL_CURSOR_DYNAMIC)
  nSuccess := oCursor:execute()
elseif nMode == 2
  // retrieve a max of 1000 rows and convert date-time values to Xbase++ dates (loose time portion)
  oCursor  := SQLDataSet():new(cStatement, oConnection,,,1000,,,.t.,.t.)
  nSuccess := oCursor:execute() // don't really need to execute an SQLDataSet, it's just here for consistency
elseif nMode == 3
  oCursor  := SQLSelect():new(cStatement, oConnection, SQL_CONCUR_LOCK, SQL_CURSOR_DYNAMIC)
  nSuccess := oCursor:execute()
elseif nMode == 4	// ako 2 ale dovol nata 10000 riadkov
  // retrieve a max of 1000 rows and convert date-time values to Xbase++ dates (loose time portion)
  oCursor  := SQLDataSet():new(cStatement, oConnection,,,1000000,,,.t.,.t.)
  nSuccess := oCursor:execute() // don't really need to execute an SQLDataSet, it's just here for consistency
endif

oConnection:displayErrors := .f.

RETURN oCursor


******************************************
FUNCTION SQLFieldBlock( oCursor, nField )
******************************************

Return {|x|iif(Pcount()==0, oCursor:fieldGet(nField), oCursor:fieldPut(nField, x))}

******************************************
FUNCTION SQLFieldBlock2( oCursor, nField )	// prava pre konverziu ANSI to OEM
******************************************

Return {|x|iif(Pcount()==0, iif( !empty(oCursor:fieldGet(nField)) , convtooemCP( oCursor:fieldGet(nField) )," ") , oCursor:fieldPut(nField, x))}

******************************************
FUNCTION SQLFieldBlock5( oCursor, nField )	// prava pre konverziu ANSI to OEM
******************************************

Return {|x|iif(Pcount()==0, iif( !empty(oCursor:fieldGet(nField)), lat_ibm(upper( oCursor:fieldGet(nField))) ," ") , oCursor:fieldPut(nField, x))}

**************************************************
FUNCTION SQLSortBlock( oCursor, nField, nColumn )
**************************************************

RETURN {|a,b,descend|oCursor:sort(IIF(descend,;
              {|x,y|IIF(Valtype(x[nField])='C', ;
                    Upper(x[nField]) > Upper(y[nField]), x[nField] > y[nField])}, ;
              {|x,y|IIF(Valtype(x[nField])='C', ;
                    Upper(x[nField]) < Upper(y[nField]), x[nField] < y[nField])})), ;
              nColumn := nField}


**********************************
FUNCTION LAT_IBM(ptext)        // Funkcia pre odstranenie diakritiky z textu v LATIN-2
**********************************         // funkcne identicka s LAT_IBM z FoxPro CS Lib
* pvodn verzia pre DOS Latin 2 - CP852
*****************************************************
* potrebn pre dulne porovnvanie oboch kdovch strnok

LOCAL outriadok:="",pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet

                znak:=asc(ptext[i])

*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127 .or. znak=42 .or. znak=63
                DO CASE
                CASE znak==128
                        znak:=67
                CASE znak==129
                        znak:=117
                CASE znak==130
                        znak:=101
                CASE znak==131
                        znak:=97
                CASE znak==132
                        znak:=97
                CASE znak==133
                        znak:=117
                CASE znak==134
                        znak:=99
                CASE znak==135
                        znak:=99
                CASE znak==136
                        znak:=108
                CASE znak==137
                        znak:=101
                CASE znak==138
                        znak:=79
                CASE znak==139
                        znak:=111
                CASE znak==140
                        znak:=105
                CASE znak==141
                        znak:=90
                CASE znak==142
                        znak:=65
                CASE znak==143
                        znak:=67
                CASE znak==144
                        znak:=69
                CASE znak==145
                        znak:=76
                CASE znak==146
                        znak:=108
                CASE znak==147
                        znak:=111
                CASE znak==148
                        znak:=111
                CASE znak==149
                        znak:=76
                CASE znak==150
                        znak:=108
                CASE znak==151
                        znak:=83
                CASE znak==152
                        znak:=115
                CASE znak==153
                        znak:=79
                CASE znak==154
                        znak:=85
                CASE znak==155
                        znak:=84
                CASE znak==156
                        znak:=116
                CASE znak==157
                        znak:=76
                CASE znak==158
                        znak:=120
                CASE znak==159
                        znak:=99
                CASE znak==160
                        znak:=97
                CASE znak==161
                        znak:=105
                CASE znak==162
                        znak:=111
                CASE znak==163
                        znak:=117
                CASE znak==164
                        znak:=65
                CASE znak==165
                        znak:=97
                CASE znak==166
                        znak:=90
                CASE znak==167
                        znak:=122
                CASE znak==168
                        znak:=69
                CASE znak==169
                        znak:=101
                CASE znak==170
                        znak:=32
                CASE znak==171
                        znak:=122
                CASE znak==172
                        znak:=67
                CASE znak==173
                        znak:=115
                CASE znak==181
                        znak:=65
                CASE znak==182
                        znak:=65
                CASE znak==183
                        znak:=69
                CASE znak==184
                        znak:=83
                CASE znak==189
                        znak:=90
                CASE znak==190
                        znak:=122
                CASE znak==198
                        znak:=65
                CASE znak==199
                        znak:=97
                CASE znak==207
                        znak:=46
                CASE znak==208
                        znak:=100
                CASE znak==209
                        znak:=68
                CASE znak==210
                        znak:=68
                CASE znak==211
                        znak:=69
                CASE znak==212
                        znak:=100
                CASE znak==213
                        znak:=78
                CASE znak==214
                        znak:=73
                CASE znak==215
                        znak:=73
                CASE znak==216
                        znak:=101
                CASE znak==221
                        znak:=84
                CASE znak==222
                        znak:=85
                CASE znak==224
                        znak:=79
                CASE znak==226
                        znak:=79
                CASE znak==227
                        znak:=78
                CASE znak==228
                        znak:=110
                CASE znak==229
                        znak:=110
                CASE znak==230
                        znak:=83
                CASE znak==231
                        znak:=115
                CASE znak==232
                        znak:=82
                CASE znak==233
                        znak:=85
                CASE znak==234
                        znak:=114
                CASE znak==235
                        znak:=85
                CASE znak==236
                        znak:=121
                CASE znak==237
                        znak:=89
                CASE znak==238
                        znak:=116
                CASE znak==239
                        znak:=46
                CASE znak==240
                        znak:=46
                CASE znak==241
                        znak:=46
                CASE znak==242
                        znak:=46
                CASE znak==243
                        znak:=46
                CASE znak==244
                        znak:=46
                CASE znak==245
                        znak:=173
                CASE znak==247
                        znak:=46
                CASE znak==248
                        znak:=46
                CASE znak==249
                        znak:=46
                CASE znak==251
                        znak:=117
                CASE znak==252
                        znak:=82
                CASE znak==253
                        znak:=114
                * doplnenie spracovania aj wildcard pre hladtext iba
                ** hviezdika *
                CASE znak==42
                        znak:=42
                ** otznik ?
                CASE znak==63
                        znak:=63
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok

***************************************
FUNCTION LAT_IBM_U(ptext)                 // Funkcia pre odstranenie diakritiky z textu v LATIN-2
***************************************
* upraven pre Windows CE,EE CP1250
**************************************************
* Prekdovanie je poda tabuku Windows CE, EE CP1250 do kdov bez diakritiky
* zkladn ASCII ktor je spolon pre vetky kdov strnky od chr 0 do 127

LOCAL outriadok:=space(0),pocet:=0,i:=0,znak:=0

pocet:=len(ptext)                && zistenie poctu znakov v riadku

* cyklus pre nacitavanie znakov a konvertovany zapis do vystupu
for i=1 to pocet
                znak:=asc(ptext[i])

                * prekduje znaky s diakritikou do kdov bez
                * ostatn nevyuit kdy nech tak
*qqq prava pre obmedzenie konverzie iba pre znaky s diakritikou
if znak>127
                DO CASE
*                CASE znak==128
*                        znak:=67
*                CASE znak==129
*                        znak:=117
*                CASE znak==130
*                        znak:=101
*                CASE znak==131
*                        znak:=97
*                CASE znak==132
*                        znak:=97
*                CASE znak==133
*                        znak:=117
*                CASE znak==134
*                        znak:=99
*                CASE znak==135
*                        znak:=99
*                CASE znak==136
*                        znak:=108
*                CASE znak==137
*                        znak:=101
                * 
                CASE znak==138
                        znak:=83
*                CASE znak==139
*                        znak:=111
*                CASE znak==140
*                        znak:=105
                * 
                CASE znak==141
                        znak:=84
                * 
                CASE znak==142
                        znak:=90
*                CASE znak==143
*                        znak:=67
*                CASE znak==144
*                        znak:=69
*                CASE znak==145
*                        znak:=76
*                CASE znak==146
*                        znak:=108
*                CASE znak==147
*                        znak:=111
*                CASE znak==148
*                        znak:=111
*                CASE znak==149
*                        znak:=76
*                CASE znak==150
*                        znak:=108
*                CASE znak==151
*                        znak:=83
*                CASE znak==152
*                        znak:=115
*                CASE znak==153
*                        znak:=79
                * 
                CASE znak==154
                        znak:=115
*                CASE znak==155
*                        znak:=84
*                CASE znak==156
*                        znak:=116
                * 
                CASE znak==157
                        znak:=116
                * 
                CASE znak==158
                        znak:=122
*                CASE znak==159
*                        znak:=99
*                CASE znak==160
*                        znak:=97
*                CASE znak==161
*                        znak:=105
*                CASE znak==162
*                        znak:=111
*                CASE znak==163
*                        znak:=117
*                CASE znak==164
*                        znak:=65
*                CASE znak==165
*                        znak:=97
*                CASE znak==166
*                        znak:=90
*                CASE znak==167
*                        znak:=122
*                CASE znak==168
*                        znak:=69
*                CASE znak==169
*                        znak:=101
*                CASE znak==170
*                        znak:=32
*                CASE znak==171
*                        znak:=122
*                CASE znak==172
*                        znak:=67
*                CASE znak==173
*                        znak:=115
*                CASE znak==174
*                        znak:=115
*                CASE znak==175
*                        znak:=115
*                CASE znak==176
*                        znak:=115
*                CASE znak==177
*                        znak:=115
*                CASE znak==178
*                        znak:=115
*                CASE znak==179
*                        znak:=115
*                CASE znak==180
*                        znak:=115
*                CASE znak==181
*                        znak:=65
*                CASE znak==182
*                        znak:=65
*                CASE znak==183
*                        znak:=69
*                CASE znak==184
*                        znak:=83
*                CASE znak==185
*                        znak:=83
*                CASE znak==186
*                        znak:=83
*                CASE znak==187
*                        znak:=83
                * 
                CASE znak==188
                        znak:=76
*                CASE znak==189
*                        znak:=90
                * 
                CASE znak==190
                        znak:=108
*                CASE znak==191
*                        znak:=108
                * 
                CASE znak==192
                        znak:=82
                * 
                CASE znak==193
                        znak:=65
*                CASE znak==194
*                        znak:=108
*                CASE znak==195
*                        znak:=108
                * A irok
                CASE znak==196
                        znak:=65
                * 
                CASE znak==197
                        znak:=76
*                CASE znak==198
*                        znak:=65
*                CASE znak==199
*                        znak:=97
                * 
                CASE znak==200
                        znak:=67
                * 
                CASE znak==201
                        znak:=69
*                CASE znak==202
*                        znak:=46
                * E s dvoma bodkami
                CASE znak==203
                        znak:=69
                * 
                CASE znak==204
                        znak:=69
                * 
                CASE znak==205
                        znak:=73
*                CASE znak==206
*                        znak:=46
                * 
                CASE znak==207
                        znak:=68
*                CASE znak==208
*                        znak:=100
*                CASE znak==209
*                        znak:=68
                * 
                CASE znak==210
                        znak:=78
                * 
                CASE znak==211
                        znak:=79
                * O s vkaom
                CASE znak==212
                        znak:=79
                * O s dvoma iarkami
                CASE znak==213
                        znak:=79
                * O s dvoma bodkami
                CASE znak==214
                        znak:=79
*                CASE znak==215
*                        znak:=73
                * 
                CASE znak==216
                        znak:=82
                * U s krkom
                CASE znak==217
                        znak:=85
                * 
                CASE znak==218
                        znak:=85
                * U s dvoma iarkami
                CASE znak==219
                        znak=85
                * U s dvoma bodkami
                CASE znak==220
                        znak:=85
                * 
                CASE znak==221
                        znak:=89
*                CASE znak==222
*                        znak:=85
*                CASE znak==223
*                        znak:=85
                * 
                CASE znak==224
                        znak:=114
                * 
                CASE znak==225
                        znak:=97
*                CASE znak==226
*                        znak:=79
*                CASE znak==227
*                        znak:=78
                * 
                CASE znak==228
                        znak:=97
                * 
                CASE znak==229
                        znak:=108
*                CASE znak==230
*                        znak:=83
*                CASE znak==231
*                        znak:=115
                * 
                CASE znak==232
                        znak:=99
                * 
                CASE znak==233
                        znak=101
*                CASE znak==234
*                        znak:=114
*                CASE znak==235
*                        znak:=85
                * 
                CASE znak==236
                        znak:=101
                * 
                CASE znak==237
                        znak:=105
*                CASE znak==238
*                        znak:=116
                * 
                CASE znak==239
                        znak:=100
*                CASE znak==240
*                        znak:=46
*                CASE znak==241
*                        znak:=46
                * 
                CASE znak==242
                        znak:=110
                * 
                CASE znak==243
                        znak:=111
                * 
                CASE znak==244
                        znak=111
                * o s dvoma iarkami
                CASE znak==245
                        znak:=111
                * o s dvoma bodkami
                CASE znak==246
                        znak:=111
*                CASE znak==247
*                        znak:=46
                * 
                CASE znak==248
                        znak:=114
                * u s krkom
                CASE znak==249
                        znak:=117
                * 
                CASE znak==250
                        znak:=117
                * u s dvoma iarkami
                CASE znak==251
                        znak:=117
                * u s dvoma bodkami
                CASE znak==252
                        znak:=117
                * 
                CASE znak==253
                        znak:=121
*                CASE znak==254
*                        znak:=114
*                CASE znak==255
*                        znak:=114
                ENDCASE
endif
                outriadok+=chr(znak)
next

RETURN outriadok



****************************
* FUNCTION LADENIE *                && pomocn okienko pre zobrazenie dajov pri laden
****************************	   && programu, parameter
FUNCTION ladenie
LOCAL oldcol, nChoice
PARAMETERS infoudaje
        nChoice=1
        oznam=infoudaje
        DCMSGBOX oznam ;
	TITLE " Ladenie... ";
                BUTTONS {"OK"} ;
                HORIZONTAL ;
	ICON XBPSTATIC_SYSICON_ICONINFORMATION ;
                CHOICE @nChoice	
return nil



**************************************************	// LICENCIA SQL EXPRESS !!!
FUNCTION SQLExpressKey(); Return 91585406415.245	// <-- put your SQLExpress license key here
**************************************************

